04a348c05678ca1fbe665ae836d7b25bcfeba51c
[people/teissler/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.2-test"
28 GIT_BRANCH=rspezial:rspezial # Version number
29 SLOGAN="www.ipfire.org" # Software slogan
30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
31 NICE=10 # Nice level
32 MAX_RETRIES=1 # prefetch/check loop
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
35
36 IPFVER="full" # Which versions should be compiled? (full|devel)
37
38 # Debian specific settings
39 if [ ! -e /etc/debian_version ]; then
40 FULLPATH=`which $0`
41 else
42 if [ -x /usr/bin/realpath ]; then
43 FULLPATH=`/usr/bin/realpath $0`
44 else
45 echo "ERROR: Need to do apt-get install realpath"
46 exit 1
47 fi
48 fi
49
50 PWD=`pwd`
51 BASENAME=`basename $0`
52 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
53 LOGFILE=$BASEDIR/log/_build.preparation.log
54 export BASEDIR LOGFILE
55 DIR_CHK=$BASEDIR/cache/check
56 mkdir $BASEDIR/log/ 2>/dev/null
57
58 # Include funtions
59 . tools/make-functions
60
61 if [ -f .config ]; then
62 . .config
63 else
64 echo -e "${BOLD}No configuration found!${NORMAL}"
65 echo -ne "Do you want to create one (y/N)?"
66 read CREATE_CONFIG
67 echo ""
68 if [ "$CREATE_CONFIG" == "y" ]; then
69 make_config
70 fi
71 fi
72
73 if [ -z $EDITOR ]; then
74 for i in nano emacs vi; do
75 EDITOR=$(which $i 2>/dev/null)
76 if ! [ -z $EDITOR ]; then
77 export EDITOR=$EDITOR
78 break
79 fi
80 done
81 [ -z $EDITOR ] && exiterror "You should have installed an editor."
82 fi
83
84 prepareenv() {
85 ############################################################################
86 # #
87 # Are we running the right shell? #
88 # #
89 ############################################################################
90 if [ ! "$BASH" ]; then
91 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
92 fi
93
94 if [ -z "${BASH_VERSION}" ]; then
95 exiterror "Not running BASH shell."
96 fi
97
98
99 ############################################################################
100 # #
101 # Trap on emergency exit #
102 # #
103 ############################################################################
104 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
105
106
107 ############################################################################
108 # #
109 # Resetting our nice level #
110 # #
111 ############################################################################
112 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
113 renice $NICE $$ > /dev/null
114 if [ `nice` != "$NICE" ]; then
115 beautify message FAIL
116 exiterror "Failed to set correct nice level"
117 else
118 beautify message DONE
119 fi
120
121
122 ############################################################################
123 # #
124 # Checking if running as root user #
125 # #
126 ############################################################################
127 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
128 if [ `id -u` != 0 ]; then
129 beautify message FAIL
130 exiterror "Not building as root"
131 else
132 beautify message DONE
133 fi
134
135
136 ############################################################################
137 # #
138 # Checking for necessary temporary space #
139 # #
140 ############################################################################
141 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
142 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
143 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
144 if (( 2048000 > $BASE_ASPACE )); then
145 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
146 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
147 beautify message FAIL
148 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
149 fi
150 else
151 beautify message DONE
152 fi
153
154 ############################################################################
155 # #
156 # Building Linux From Scratch system #
157 # #
158 ############################################################################
159 # Set umask
160 umask 022
161
162 # Set LFS Directory
163 LFS=$BASEDIR/build
164
165 # Check /tools symlink
166 if [ -h /tools ]; then
167 rm -f /tools
168 fi
169 if [ ! -a /tools ]; then
170 ln -s $BASEDIR/build/tools /
171 fi
172 if [ ! -h /tools ]; then
173 exiterror "Could not create /tools symbolic link."
174 fi
175
176 # Setup environment
177 set +h
178 LC_ALL=POSIX
179 MAKETUNING="-j6"
180 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
181 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
182
183 # Make some extra directories
184 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
185 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
186 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
187 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
188
189 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
190 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
191
192 # Make all sources and proc available under lfs build
193 mount --bind /dev $BASEDIR/build/dev
194 mount --bind /dev/pts $BASEDIR/build/dev/pts
195 mount --bind /dev/shm $BASEDIR/build/dev/shm
196 mount --bind /proc $BASEDIR/build/proc
197 mount --bind /sys $BASEDIR/build/sys
198 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
199 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
200 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
201 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
202 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
203 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
204 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
205 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
206 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
207
208 # This is a temporary hack!!!
209 if [ ! -f /tools/bin/hostname ]; then
210 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
211 fi
212
213 # Run LFS static binary creation scripts one by one
214 export CCACHE_DIR=$BASEDIR/ccache
215 export CCACHE_HASHDIR=1
216
217 # Remove pre-install list of installed files in case user erase some files before rebuild
218 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
219 }
220
221 buildtoolchain() {
222 LOGFILE="$BASEDIR/log/_build.toolchain.log"
223 export LOGFILE
224 ORG_PATH=$PATH
225 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
226 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
227 lfsmake1 ccache
228 lfsmake1 binutils PASS=1
229 lfsmake1 gcc PASS=1
230 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
231 lfsmake1 linux-libc-header
232 lfsmake1 glibc
233 lfsmake1 cleanup-toolchain PASS=1
234 lfsmake1 tcl
235 lfsmake1 expect
236 lfsmake1 dejagnu
237 lfsmake1 gcc PASS=2
238 lfsmake1 binutils PASS=2
239 lfsmake1 ncurses
240 lfsmake1 bash
241 lfsmake1 bzip2
242 lfsmake1 coreutils
243 lfsmake1 diffutils
244 lfsmake1 findutils
245 lfsmake1 gawk
246 lfsmake1 gettext
247 lfsmake1 grep
248 lfsmake1 gzip
249 lfsmake1 m4
250 lfsmake1 make
251 lfsmake1 patch
252 lfsmake1 perl
253 lfsmake1 sed
254 lfsmake1 tar
255 lfsmake1 texinfo
256 lfsmake1 util-linux
257 lfsmake1 cleanup-toolchain PASS=2
258 export PATH=$ORG_PATH
259 }
260
261 buildbase() {
262 LOGFILE="$BASEDIR/log/_build.base.log"
263 export LOGFILE
264 lfsmake2 stage2
265 lfsmake2 linux-libc-header
266 lfsmake2 man-pages
267 lfsmake2 glibc
268 lfsmake2 cleanup-toolchain PASS=3
269 lfsmake2 binutils
270 lfsmake2 gcc
271 lfsmake2 berkeley
272 lfsmake2 coreutils
273 lfsmake2 iana-etc
274 lfsmake2 m4
275 lfsmake2 bison
276 lfsmake2 ncurses
277 lfsmake2 procps
278 lfsmake2 sed
279 lfsmake2 libtool
280 lfsmake2 perl
281 lfsmake2 readline
282 lfsmake2 zlib
283 lfsmake2 autoconf
284 lfsmake2 automake
285 lfsmake2 bash
286 lfsmake2 bzip2
287 lfsmake2 diffutils
288 lfsmake2 e2fsprogs
289 lfsmake2 ed
290 lfsmake2 file
291 lfsmake2 findutils
292 lfsmake2 flex
293 lfsmake2 gawk
294 lfsmake2 gettext
295 lfsmake2 grep
296 lfsmake2 groff
297 lfsmake2 gzip
298 lfsmake2 inetutils
299 lfsmake2 iproute2
300 lfsmake2 kbd
301 lfsmake2 less
302 lfsmake2 libaal
303 lfsmake2 make
304 lfsmake2 man
305 lfsmake2 mktemp
306 lfsmake2 modutils
307 lfsmake2 mtd
308 lfsmake2 net-tools
309 lfsmake2 patch
310 lfsmake2 psmisc
311 lfsmake2 reiser4progs
312 lfsmake2 shadow
313 lfsmake2 sysklogd
314 lfsmake2 sysvinit
315 lfsmake2 tar
316 lfsmake2 texinfo
317 lfsmake2 udev
318 lfsmake2 util-linux
319 lfsmake2 vim
320 lfsmake2 grub
321 }
322
323 buildipfire() {
324 LOGFILE="$BASEDIR/log/_build.ipfire.log"
325 export LOGFILE
326 ipfiremake configroot
327 ipfiremake backup
328 ipfiremake dhcp
329 ipfiremake dhcpcd
330 ipfiremake libusb
331 ipfiremake libpcap
332 ipfiremake ppp
333 ipfiremake rp-pppoe
334 ipfiremake unzip
335 ipfiremake linux SMP=1
336 ipfiremake linux-fusion SMP=1
337 ipfiremake ipp2p SMP=1
338 ipfiremake zaptel SMP=1
339 ipfiremake r8169 SMP=1
340 ipfiremake r8168 SMP=1
341 ipfiremake atl1 SMP=1
342 ipfiremake kqemu SMP=1
343 ipfiremake v4l-dvb SMP=1
344 ipfiremake madwifi SMP=1
345 ipfiremake sane KMOD=1 SMP=1
346 ipfiremake linux
347 ipfiremake linux-fusion
348 ipfiremake ipp2p
349 ipfiremake zaptel
350 ipfiremake r8169
351 ipfiremake r8168
352 ipfiremake atl1
353 ipfiremake kqemu
354 ipfiremake v4l-dvb
355 ipfiremake madwifi
356 ipfiremake sane KMOD=1
357 ipfiremake pkg-config
358 ipfiremake linux-atm
359 ipfiremake cpio
360 ipfiremake klibc
361 ipfiremake mkinitcpio
362 ipfiremake udev KLIBC=1
363 ipfiremake expat
364 ipfiremake gdbm
365 ipfiremake gmp
366 ipfiremake pam
367 ipfiremake openssl
368 ipfiremake curl
369 ipfiremake python
370 ipfiremake libnet
371 ipfiremake libidn
372 ipfiremake libjpeg
373 ipfiremake libpng
374 ipfiremake libtiff
375 ipfiremake libart
376 ipfiremake freetype
377 ipfiremake gd
378 ipfiremake popt
379 ipfiremake pcre
380 ipfiremake slang
381 ipfiremake newt
382 ipfiremake libcap
383 ipfiremake pciutils
384 ipfiremake usbutils
385 ipfiremake libxml2
386 ipfiremake libxslt
387 ipfiremake BerkeleyDB
388 ipfiremake mysql
389 ipfiremake cyrus-sasl
390 ipfiremake openldap
391 ipfiremake apache2
392 ipfiremake php
393 ipfiremake apache2 PASS=C
394 ipfiremake arping
395 ipfiremake beep
396 ipfiremake bind
397 ipfiremake cdrtools
398 ipfiremake dnsmasq
399 ipfiremake dosfstools
400 ipfiremake squashfstools
401 ipfiremake reiserfsprogs
402 ipfiremake xfsprogs
403 ipfiremake sysfsutils
404 ipfiremake fuse
405 ipfiremake ntfs-3g
406 ipfiremake ethtool
407 ipfiremake ez-ipupdate
408 ipfiremake fcron
409 ipfiremake perl-GD
410 ipfiremake GD-Graph
411 ipfiremake GD-TextUtil
412 ipfiremake gnupg
413 ipfiremake hdparm
414 ipfiremake sdparm
415 ipfiremake mtools
416 ipfiremake initscripts
417 ipfiremake whatmask
418 ipfiremake iptables
419 ipfiremake libupnp
420 ipfiremake ipp2p IPT=1
421 ipfiremake linux-igd
422 ipfiremake ipaddr
423 ipfiremake iptstate
424 ipfiremake iputils
425 ipfiremake l7-protocols
426 ipfiremake mISDN
427 ipfiremake capi4k-utils
428 ipfiremake hwdata
429 ipfiremake kudzu
430 ipfiremake logrotate
431 ipfiremake logwatch
432 ipfiremake misc-progs
433 ipfiremake nano
434 ipfiremake nasm
435 ipfiremake URI
436 ipfiremake HTML-Tagset
437 ipfiremake HTML-Parser
438 ipfiremake Compress-Zlib
439 ipfiremake Digest
440 ipfiremake Digest-SHA1
441 ipfiremake Digest-HMAC
442 ipfiremake libwww-perl
443 ipfiremake Net-DNS
444 ipfiremake Net-IPv4Addr
445 ipfiremake Net_SSLeay
446 ipfiremake IO-Stringy
447 ipfiremake Unix-Syslog
448 ipfiremake Mail-Tools
449 ipfiremake MIME-Tools
450 ipfiremake Net-Server
451 ipfiremake Convert-TNEF
452 ipfiremake Convert-UUlib
453 ipfiremake Archive-Tar
454 ipfiremake Archive-Zip
455 ipfiremake Text-Tabs+Wrap
456 ipfiremake Locale-Country
457 ipfiremake XML-Parser
458 ipfiremake glib
459 ipfiremake GeoIP
460 ipfiremake fwhits
461 ipfiremake noip_updater
462 ipfiremake ntp
463 ipfiremake openssh
464 ipfiremake openswan
465 ipfiremake rrdtool
466 ipfiremake setserial
467 ipfiremake setup
468 ipfiremake snort
469 ipfiremake oinkmaster
470 ipfiremake squid
471 ipfiremake squid-graph
472 ipfiremake squidguard
473 ipfiremake calamaris
474 ipfiremake tcpdump
475 ipfiremake traceroute
476 ipfiremake vlan
477 ipfiremake wireless
478 ipfiremake libsafe
479 ipfiremake pakfire
480 ipfiremake java
481 ipfiremake spandsp
482 ipfiremake lzo
483 ipfiremake openvpn
484 ipfiremake pammysql
485 ipfiremake cups
486 ipfiremake ghostscript
487 ipfiremake foomatic
488 ipfiremake hplip
489 ipfiremake samba
490 ipfiremake sudo
491 ipfiremake mc
492 ipfiremake wget
493 ipfiremake bridge-utils
494 ipfiremake screen
495 ipfiremake hddtemp
496 ipfiremake smartmontools
497 ipfiremake htop
498 ipfiremake postfix
499 ipfiremake fetchmail
500 ipfiremake cyrus-imapd
501 ipfiremake openmailadmin
502 ipfiremake clamav
503 ipfiremake spamassassin
504 ipfiremake amavisd
505 ipfiremake alsa
506 ipfiremake mpg123
507 ipfiremake mpfire
508 ipfiremake guardian
509 ipfiremake libid3tag
510 ipfiremake libmad
511 ipfiremake libogg
512 ipfiremake libvorbis
513 ipfiremake libdvbpsi
514 ipfiremake lame
515 ipfiremake sox
516 ipfiremake libshout
517 ipfiremake icecast
518 ipfiremake icegenerator
519 ipfiremake mpd
520 ipfiremake mpc
521 ipfiremake xvid
522 ipfiremake libmpeg2
523 ipfiremake cmake
524 ipfiremake libpri
525 ipfiremake asterisk
526 ipfiremake gnump3d
527 ipfiremake libsigc++
528 ipfiremake applejuice
529 ipfiremake ocaml
530 ipfiremake mldonkey
531 ipfiremake libtorrent
532 ipfiremake rtorrent
533 ipfiremake ipfireseeder
534 ipfiremake rsync
535 ipfiremake tcpwrapper
536 ipfiremake portmap
537 ipfiremake nfs
538 ipfiremake nmap
539 ipfiremake ncftp
540 ipfiremake etherwake
541 ipfiremake bwm-ng
542 ipfiremake tripwire
543 ipfiremake sysstat
544 ipfiremake vsftpd
545 ipfiremake which
546 ipfiremake lsof
547 ipfiremake centerim
548 ipfiremake br2684ctl
549 ipfiremake pcmciautils
550 ipfiremake lm_sensors
551 ipfiremake collectd
552 ipfiremake lcd4linux
553 ipfiremake neon
554 ipfiremake subversion
555 ipfiremake tcptrack
556 ipfiremake teamspeak
557 ipfiremake elinks
558 ipfiremake igmpproxy
559 ipfiremake fbset
560 ipfiremake sdl
561 ipfiremake qemu
562 ipfiremake sane
563 ipfiremake netpbm
564 ipfiremake phpSANE
565 ipfiremake tunctl
566 ipfiremake nagios
567 ipfiremake ebtables
568 ipfiremake arptables
569 ipfiremake fontconfig
570 ipfiremake freefont
571 ipfiremake directfb
572 ipfiremake dfb++
573 ipfiremake ffmpeg
574 ipfiremake videolan
575 ipfiremake vdr
576 ipfiremake w_scan
577 ipfiremake git
578 ipfiremake squidclamav
579 ipfiremake bc
580 ipfiremake esniper
581 ipfiremake mod_perl
582 ipfiremake vnstat
583 ipfiremake vnstati
584 ipfiremake wpa_supplicant
585 ipfiremake hostapd}
586
587 buildinstaller() {
588 # Run installer scripts one by one
589 LOGFILE="$BASEDIR/log/_build.installer.log"
590 export LOGFILE
591 ipfiremake syslinux
592 ipfiremake as86
593 ipfiremake mbr
594 ipfiremake memtest
595 installmake linux-libc-header
596 installmake binutils
597 ipfiremake uClibc PASS=1
598 ipfiremake gcc INST=1
599 installmake uClibc PASS=2
600 installmake gcc INST=2
601 installmake uClibc PASS=3
602 installmake busybox
603 installmake udev
604 installmake slang
605 installmake newt
606 installmake gettext
607 installmake kbd
608 installmake popt
609 installmake sysvinit
610 installmake misc-progs
611 installmake libaal
612 installmake reiser4progs
613 installmake reiserfsprogs
614 installmake sysfsutils
615 installmake util-linux
616 installmake pciutils
617 installmake zlib
618 installmake mtd
619 installmake wget
620 installmake hwdata
621 installmake kudzu
622 installmake pcmciautils
623 installmake installer
624 installmake initrd
625 }
626
627 buildpackages() {
628 LOGFILE="$BASEDIR/log/_build.packages.log"
629 export LOGFILE
630 echo "... see detailed log in _build.*.log files" >> $LOGFILE
631
632 installmake strip
633
634 # Generating list of packages used
635 echo -n "Generating packages list from logs" | tee -a $LOGFILE
636 rm -f $BASEDIR/doc/packages-list
637 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
638 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
639 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
640 fi
641 done
642 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
643 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
644 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
645 rm -f $BASEDIR/doc/packages-list
646 # packages-list.txt is ready to be displayed for wiki page
647 beautify message DONE
648
649 # Create images for install
650 ipfiremake cdrom ED=full
651
652 # Check if there is a loop device for building in virtual environments
653 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
654 ipfiremake usb-stick
655 fi
656
657 # Create updater package
658 ipfiremake updater
659 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
660
661 ipfirepackages
662
663 # Cleanup
664 stdumount
665 rm -rf $BASEDIR/build/tmp/*
666
667 # Generating total list of files
668 echo -n "Generating files list from logs" | tee -a $LOGFILE
669 rm -f $BASEDIR/log/FILES
670 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
671 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
672 echo "##" >>$BASEDIR/log/FILES
673 echo "## `basename $i`" >>$BASEDIR/log/FILES
674 echo "##" >>$BASEDIR/log/FILES
675 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
676 fi
677 done
678 beautify message DONE
679
680 cd $PWD
681 }
682
683 ipfirepackages() {
684 #ipfiremake core-updates
685 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
686 if [ -e $BASEDIR/lfs/$i ]; then
687 ipfiredist $i
688 else
689 echo -n $i
690 beautify message SKIP
691 fi
692 done
693 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
694 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
695 rm -rf $BASEDIR/build/install/packages/*
696 }
697
698 # See what we're supposed to do
699 case "$1" in
700 build)
701 clear
702 BUILDMACHINE=`uname -m`
703 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
704 #only restore on a clean disk
705 if [ ! -f log/cleanup-toolchain-2-tools ]; then
706 if [ ! -n "$PACKAGE" ]; then
707 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
708 prepareenv
709 buildtoolchain
710 else
711 PACKAGENAME=${PACKAGE%.tar.gz}
712 beautify build_stage "Packaged toolchain compilation"
713 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
714 tar zxf $PACKAGE
715 prepareenv
716 else
717 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
718 fi
719 fi
720 else
721 echo -n "Using installed toolchain" | tee -a $LOGFILE
722 beautify message SKIP
723 prepareenv
724 fi
725
726 beautify build_start
727 beautify build_stage "Building LFS"
728 buildbase
729
730 beautify build_stage "Building IPFire"
731 buildipfire
732
733 beautify build_stage "Building installer"
734 buildinstaller
735
736 beautify build_stage "Building packages"
737 buildpackages
738 beautify build_end
739 ;;
740 shell)
741 # enter a shell inside LFS chroot
742 # may be used to changed kernel settings
743 prepareenv
744 entershell
745 ;;
746 clean)
747 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
748 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
749 $LOSETUP -d $i 2>/dev/null
750 done
751 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
752 umount $i
753 done
754 stdumount
755 for i in `seq 0 7`; do
756 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
757 umount /dev/loop${i} 2>/dev/null;
758 losetup -d /dev/loop${i} 2>/dev/null;
759 fi;
760 done
761 rm -rf $BASEDIR/build
762 rm -rf $BASEDIR/cdrom
763 rm -rf $BASEDIR/packages
764 rm -rf $BASEDIR/log
765 if [ -h /tools ]; then
766 rm -f /tools
767 fi
768 beautify message DONE
769 ;;
770 downloadsrc)
771 if [ ! -d $BASEDIR/cache ]; then
772 mkdir $BASEDIR/cache
773 fi
774 mkdir -p $BASEDIR/log
775 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
776 FINISHED=0
777 cd $BASEDIR/lfs
778 for c in `seq $MAX_RETRIES`; do
779 if (( FINISHED==1 )); then
780 break
781 fi
782 FINISHED=1
783 cd $BASEDIR/lfs
784 for i in *; do
785 if [ -f "$i" -a "$i" != "Config" ]; then
786 echo -ne "Loading $i"
787 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
788 if [ $? -ne 0 ]; then
789 beautify message FAIL
790 FINISHED=0
791 else
792 if [ $c -eq 1 ]; then
793 beautify message DONE
794 fi
795 fi
796 fi
797 done
798 done
799 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
800 ERROR=0
801 for i in *; do
802 if [ -f "$i" -a "$i" != "Config" ]; then
803 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
804 if [ $? -ne 0 ]; then
805 echo -ne "MD5 difference in lfs/$i"
806 beautify message FAIL
807 ERROR=1
808 fi
809 fi
810 done
811 if [ $ERROR -eq 0 ]; then
812 echo -ne "${BOLD}all files md5sum match${NORMAL}"
813 beautify message DONE
814 else
815 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
816 beautify message FAIL
817 fi
818 cd - >/dev/null 2>&1
819 ;;
820 toolchain)
821 clear
822 prepareenv
823 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
824 buildtoolchain
825 BUILDMACHINE=`uname -m`
826 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
827 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
828 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
829 build/{bin,etc,usr/bin,usr/local} \
830 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
831 log >> $LOGFILE
832 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
833 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
834 stdumount
835 ;;
836 gettoolchain)
837 BUILDMACHINE=`uname -m`
838 # arbitrary name to be updated in case of new toolchain package upload
839 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
840 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
841 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
842 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
843 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
844 cd $BASEDIR/cache/toolchains
845 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
846 if [ $? -ne 0 ]; then
847 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
848 else
849 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
850 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
851 else
852 exiterror "$PACKAGE.md5 did not match, check downloaded package"
853 fi
854 fi
855 else
856 echo "Toolchain is already downloaded. Exiting..."
857 fi
858 ;;
859 othersrc)
860 prepareenv
861 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
862 chroot $LFS /tools/bin/env -i HOME=/root \
863 TERM=$TERM PS1='\u:\w\$ ' \
864 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
865 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
866 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
867 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
868 if [ $? -eq "0" ]; then
869 beautify message DONE
870 else
871 beautify message FAIL
872 fi
873 stdumount
874 ;;
875 git)
876 case "$2" in
877 update|up)
878 git pull
879 ;;
880 commit|ci)
881 shift 2
882 git commit $*
883
884 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
885
886 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
887 read
888 [ -z $REPLY ] && exit 0
889 for i in y Y j J; do
890 if [ "$i" == "$REPLY" ]; then
891 $0 git push
892 exit $?
893 fi
894 done
895 exiterror "\"$REPLY\" is not a valid answer."
896 ;;
897 dist)
898 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
899 ;;
900 diff|di)
901 echo -ne "Make a local diff to last revision"
902 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
903 evaluate 1
904 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
905 git diff --stat
906 ;;
907 push)
908 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
909 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
910
911 git push ${GIT_URL} ${GIT_BRANCH}
912 ;;
913 esac
914 ;;
915 uploadsrc)
916 PWD=`pwd`
917 cd $BASEDIR/cache/
918 echo -e "Uploading cache to ftp server:"
919 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
920 for i in *; do
921 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
922 grep -q $(basename $i) /tmp/ftplist
923 if [ "$?" -ne "0" ]; then
924 echo -ne "$(basename $i)"
925 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
926 if [ "$?" -ne "0" ]; then
927 beautify message FAIL
928 fi
929 fi
930 done
931 rm -f /tmp/ftplist
932 cd $PWD
933 exit 0
934 ;;
935 upload)
936 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
937 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
938 if [ -z $FTP_ISO_PORT ]; then
939 FTP_ISO_PORT=21
940 fi
941 cat <<EOF > .ftp-commands
942 mkdir -p $FTP_ISO_PATH$SVN_REVISION
943 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
944 quit
945 EOF
946 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
947 rm -f .ftp-commands
948
949 case "$2" in
950 iso)
951 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
952
953 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
954 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
955 if [ -e "$i" ]; then
956 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
957 if [ "$?" -eq "0" ]; then
958 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
959 else
960 echo "There was an error while uploading the file $i to the ftp server."
961 exit 1
962 fi
963 fi
964 done
965 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
966 if [ "$3" = "--with-sources-cd" ]; then
967 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
968 fi
969 ;;
970 paks)
971 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
972 if [ "$?" -eq "0" ]; then
973 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
974 else
975 echo -e "There was an error while uploading the packages to the ftp server."
976 exit 1
977 fi
978 ;;
979 esac
980 ;;
981 batch)
982 if [ "$2" = "--background" ]; then
983 batch_script
984 exit $?
985 fi
986 if [ `screen -ls | grep -q ipfire` ]; then
987 echo "Build is already running, sorry!"
988 exit 1
989 else
990 if [ "$2" = "--rebuild" ]; then
991 export IPFIRE_REBUILD=1
992 echo "REBUILD!"
993 else
994 export IPFIRE_REBUILD=0
995 fi
996 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
997 screen -dmS ipfire $0 batch --background
998 evaluate 1
999 exit 0
1000 fi
1001 ;;
1002 watch)
1003 watch_screen
1004 ;;
1005 pxe)
1006 case "$2" in
1007 start)
1008 start_tftpd
1009 ;;
1010 stop)
1011 stop_tftpd
1012 ;;
1013 reload|restart)
1014 reload_tftpd
1015 ;;
1016 esac
1017 exit 0
1018 ;;
1019 lang)
1020 update_langs
1021 ;;
1022 "")
1023 clear
1024 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1025 do
1026 case $name in
1027 "IPFIRE: Downloadsrc")
1028 $0 downloadsrc
1029 ;;
1030 "IPFIRE: Build (silent)")
1031 $0 build-silent
1032 ;;
1033 "IPFIRE: Watch Build")
1034 $0 watch
1035 ;;
1036 "IPFIRE: Batch")
1037 $0 batch
1038 ;;
1039 "IPFIRE: Clean")
1040 $0 clean
1041 ;;
1042 "Help")
1043 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1044 cat doc/make.sh-usage
1045 ;;
1046 "LOG: Tail")
1047 tail -f log/_*
1048 ;;
1049 "Exit")
1050 break
1051 ;;
1052 esac
1053 done
1054 ;;
1055 config)
1056 make_config
1057 ;;
1058 *)
1059 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1060 cat doc/make.sh-usage
1061 ;;
1062 esac